;-----------------------------------------------------------------
; ODStatusBar.Asm
;-----------------------------------------------------------------
UNICODE	= 1
STRINGS UNICODE

#IF STRINGS UNICODE
   #include "C:\GoAsm\IncludeW\WINDOWS.inc"
   #include "C:\GoAsm\IncludeW\all_api.inc"
#ELSE
   #include "C:\GoAsm\IncludeA\WINDOWS.inc"
   #include "C:\GoAsm\IncludeA\all_api.inc"
#ENDIF


STATUSPARAM STRUCT
	pszText		DD	?
	dwColor		DD	?
	hIcon		DD	?
ENDS

	IDD_DLG1	EQU	1000
	IDC_STATIC	EQU	1001
CONST SECTION
	

DATA SECTION
	hInstance	DD 	?
	sbparts		DD	60,120,-1,0,0

	sbParams	DB	(SIZEOF STATUSPARAM * 3) DUP (?)

	sbText1		DW	"Part 1",0
	sbText2		DW	"Part 2",0
	sbText3		DW	"Part 3",0
	szClassName DW	"Custom_Class",0

	hStatus		DD	?

CODE SECTION

start:
	push	0
	call 	[GetModuleHandle]
	mov 	[hInstance],eax
	//invoke _RegisterClass,[hInstance]
	call 	_InitComControls

	;Cration du dialogue...
	push	0
	push	offset DlgProc
	push	0
	push	IDD_DLG1
	push	[hInstance]
	call	[DialogBoxParam]
	
	push	0
	call	[ExitProcess]
	
_InitComControls FRAME
	
	local iccex:INITCOMMONCONTROLSEX
	mov	D[iccex.dwSize],SIZEOF INITCOMMONCONTROLSEX
	mov	D[iccex.dwICC],ICC_WIN95_CLASSES
	push	ADDR iccex		
	call	[InitCommonControlsEx]	
	
	RET
	
endf

DlgProc FRAME hwnd,uMsg,wParam,lParam

	cmp D[uMsg],WM_INITDIALOG
	jne >>
		push	IDC_STATIC
		push	[hwnd]
		call 	[GetDlgItem]
		mov 	[hStatus],eax

		push	offset sbparts
		push	3
		push	SB_SETPARTS
		push	[hStatus]
		call	[SendMessage]
		push 	ebx

		mov 	ebx,offset sbParams
		mov 	[ebx+STATUSPARAM.pszText],offset sbText1
		mov 	D[ebx+STATUSPARAM.dwColor],00C08080h
		
		push	IDI_ASTERISK
		push	NULL
		call	[LoadIcon]
		mov 	D[ebx+STATUSPARAM.hIcon],eax
		push	ebx
		push	SBT_OWNERDRAW or 0
		push	SB_SETTEXT
		push	[hStatus]
		call	[SendMessage]

		add 	ebx, SIZEOF STATUSPARAM
		mov 	[ebx+STATUSPARAM.pszText],offset sbText2
		mov 	D[ebx+STATUSPARAM.dwColor],0080FFFFh
		push	IDI_APPLICATION
		push	NULL
		call	[LoadIcon]
		mov 	D[ebx+STATUSPARAM.hIcon],eax
		push	ebx
		push	SBT_OWNERDRAW or 1
		push	SB_SETTEXT
		push	[hStatus]
		call	[SendMessage]

		add 	ebx, SIZEOF STATUSPARAM
		mov 	[ebx+STATUSPARAM.pszText],offset sbText3
		mov 	D[ebx+STATUSPARAM.dwColor],008080FFh
		push	IDI_WINLOGO
		push	NULL
		call	[LoadIcon]
		mov 	D[ebx+STATUSPARAM.hIcon],eax
		push	ebx
		push	SBT_OWNERDRAW or 2
		push	SB_SETTEXT
		push	[hStatus]
		call 	[SendMessage]

		pop ebx
		jmp >.EXIT

	:
	cmp D[uMsg],WM_DRAWITEM
	jne >
		mov eax,[wParam]
		xor eax,IDC_STATIC
		jnz >.EXIT
			push	[lParam]
			push	[wParam]
			call	DrawStatusParts
		jmp >.EXIT

	:
	cmp D[uMsg],WM_CLOSE
	jne >
		push	0
		push	[hwnd]
		call	[EndDialog]
	:
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

DrawStatusParts FRAME  wParam,lParam
	uses ebx, edi, esi

	mov ebx, [lParam] ; Pointer to DRAWITEMSTRUCT
	mov edi,[ebx+DRAWITEMSTRUCT.itemData] ; Pointer to STATUSPARAM for this part
	or edi,edi
	jz >.EXIT
		push	[edi+STATUSPARAM.dwColor]	
		call	[CreateSolidBrush]
		push eax
		mov esi,ebx
		add esi,DRAWITEMSTRUCT.rcItem
		invoke FillRect,[ebx+DRAWITEMSTRUCT.hdc],esi,eax
		mov eax,[edi+STATUSPARAM.hIcon]
		or eax,eax
		jz >
			invoke DrawIconEx,[ebx+DRAWITEMSTRUCT.hdc],[esi+RECT.left],[esi+RECT.top],\
				eax,16,16,NULL,NULL,DI_NORMAL
			add D[esi+RECT.left],18
		:
		invoke SetBkMode,[ebx+DRAWITEMSTRUCT.hdc],TRANSPARENT
		invoke SetTextColor,[ebx+DRAWITEMSTRUCT.hdc],0
		push	[edi+STATUSPARAM.pszText]
		call	[lstrlen]
		invoke DrawText,[ebx+DRAWITEMSTRUCT.hdc],[edi+STATUSPARAM.pszText],eax,esi,DT_LEFT
		pop 	eax
		push	eax
		call	[DeleteObject]
	.EXIT
	ret

ENDF


_RegisterClass FRAME hInst

    LOCAL		wc:WNDCLASSEX
    mov        	D[wc.cbSize],sizeof WNDCLASSEX
    mov        	D[wc.style],CS_HREDRAW or CS_VREDRAW
    mov        	[wc.lpfnWndProc],offset DlgProc
    mov        	D[wc.cbClsExtra],NULL
    mov        	D[wc.cbWndExtra],DLGWINDOWEXTRA
    push		[hInst]
    pop        	[wc.hInstance]
    invoke    	GetSysColorBrush,COLOR_BTNFACE
    mov        	[wc.hbrBackground],eax
    mov        	D[wc.lpszMenuName],NULL
    mov        	[wc.lpszClassName],offset szClassName
    invoke 		LoadIcon,NULL,IDI_APPLICATION
    mov        	[wc.hIcon],eax
    mov        	[wc.hIconSm],eax
    invoke 		LoadCursor,NULL,IDC_ARROW
    mov        	[wc.hCursor],eax
    invoke 		RegisterClassEx,addr wc
    mov			[wc],eax
    ret

endf
